/************************************************************************
 *	camt11.c       	 22-OCT-1991		Y.Takeuchi (TIT)	*
 *									*
 *	Long term run test						*
 *									*
 *	single word write & read & verify				*
 *	single long word write & read & verify				*
 *	block word transfer						*
 *		Q-STOP write & read & verify				*
 *		IGNORE-Q write & read & verify				*
 *	block long word transfer					*
 *		Q-STOP write & read & verify				*
 *		IGNORE-Q write & read & verify				*
 *	interrupt							*
 *	list file read							*
 *	list load							*
 *	list execute & verify						*
 *	list load & execute & verify					*
 *									*
 *	CAMAC Buffer Module						*
 *	CAMAC Scaler							*
 *	CAMAC ADC							*
 *	camt11 [loop_count]						*
 ************************************************************************/
#include <stdio.h>
#include <string.h>
#include "camtest.h"
#include <camlib.h>

#define DEFLOP  10
#define MAXBUF  4095
#define MAXLIST 10000
#define STEP    1
/*
#define PRINT
*/
main(argc, argv)
int argc;
char *argv[];
{
    int esinglew, eqstopw, eqignow;
    int ssinglew, sqstopw, sqignow;
    int esingle, eqstop, eqigno, einter, elist;
    int ssingle, sqstop, sqigno, sinter, slist;
    int loop, flag;
    int status, save, i, j, k, s;
    int data[MAXBUF], zero[MAXBUF];
    u_short datas[MAXBUF], zeros[MAXBUF];
    int naf, dat, q, x;
    int mode, buf[MAXBUF], len, retlen, err;
    u_short bufs[MAXBUF];
    u_short list[MAXLIST];
    struct iosb iosb;
    int lenlis;
    char filename[33];
    int print_flag = 0;

/* Read options */
    loop = (argc > 1) ? atoi(argv[1]) : DEFLOP;

/* Initialize valiable */
    strcpy(filename, "camt11.obj"); 
    esinglew = eqstopw = eqignow = 0;
    ssinglew = sqstopw = sqignow = 0;
    esingle = eqstop = eqigno = einter = elist = 0;
    ssingle = sqstop = sqigno = sinter = slist = 0;
    for (j = 0; j < MAXBUF; j++) {
	zeros[j] = zero[j] = 0;
	datas[j] = data[j] = j;
    }
    s = 1;

/* Open and Initialize CAMAC */
    CAM_Open();
    CGENC();
    CGENZ();
    CREMI();

/* loop */
    for (i = 0; i < loop; i++) {

/****************************
 *  single                  *
 ****************************/
/*
	printf("*** single *** %d\n", i);
	for (j = 0; j < 0x1000000; j++) {
	    dat = j;
	    CAMAC(NAF(CAMAC_SWITCH, 0, 16), &dat, &q, &x);
	    dat = 0;
	    CAMAC(NAF(CAMAC_SWITCH, 0,  0), &dat, &q, &x);
	    if (dat == j && q == 1 && x == 1)
	        ssingle++;
	    else {
		printf("single error q=%d x= %d dat=0x%x i=%d j=0x%x\n",
		       q, x, dat, i, j);
		esingle++;
	    }
	}

	for (j = 0; j < 0x10000; j++) {
	    dat = j;
	    CAMACW(NAF(CAMAC_SWITCH, 0, 16), &dat, &q, &x);
	    dat = 0;
	    CAMACW(NAF(CAMAC_SWITCH, 0,  0), &dat, &q, &x);
	    if (dat == j && q == 1 && x == 1) {
		ssinglew++;
	    }
	    else {
		printf("singlew error q=%d x= %d dat=0x%x i=%d j=0x%x\n",
		       q, x, dat, i, j);
		esinglew++;
	    }
	}
*/

/****************************
 *  block                   *
 ****************************/
	printf("*** block *** %d\n", i);
	dat = 0;
	for (j = 2; j < MAXBUF; j += STEP) {
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(0, NAF(CAMAC_MEMORY, 0, 16), zero, j, &retlen, &err);
	    if (err != 0)
		printf("qstop clear error err=0x%x i=%d j=%d\n", err, i, j);

	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(0, NAF(CAMAC_MEMORY, 0, 16), data, j, &retlen, &err);
	    if (err != 0)
		printf("qstop write error err=0x%x i=%d j=%d\n", err, i, j);

	    for (k = 0; k < j; k += STEP)
	        buf[k] = 2;
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(0, NAF(CAMAC_MEMORY, 0, 0), buf, j, &retlen, &err);
	    if (err != 0)
		printf("qstop read error  err=0x%x i=%d j=%d\n", err, i, j);

	    flag = 0;
	    for (k = 0; k < j ; k += STEP) {
#ifdef PRINT
		if (print_flag != 0)
		  printf("buf[%d]=0x%x data[%d]=0x%x\n",
			 k, buf[k], k, data[k]);
#endif
		if ((buf[k] & 0xFFFFFF) != data[k])
		  flag = 1;
	    }
	    if (flag == 0)
	        sqstop++;
	    else {
		printf("qstop error i=%d j=%d\n", i, j);
		print_flag = 1;
		eqstop++;
		break;
	    }
	}

	for (j = 2; j < MAXBUF; j += STEP) {
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(1, NAF(CAMAC_MEMORY, 0, 16), zero, j, &retlen, &err);
	    if (err != 0)
		printf("qigno clear error err=0x%x i=%d j=%d\n", err, i, j);

	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(1, NAF(CAMAC_MEMORY, 0, 16), data, j, &retlen, &err);
	    if (err != 0)
		printf("qigno write error err=0x%x i=%d j=%d\n", err, i, j);

	    for (k = 0; k < j; k += STEP)
	        buf[k] = 2;
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAL(1, NAF(CAMAC_MEMORY, 0, 0), buf, j, &retlen, &err);
	    if (err != 0)
		printf("qigno read error  err=0x%x i=%d j=%d\n", err, i, j);

	    flag = 0;
	    for (k = 0; k < j ; k += STEP) {
#ifdef PRINT
		if (print_flag != 0)
		printf("buf[%d]=0x%x data[%d]=0x%x\n",
		       k, buf[k], k, data[k]);
#endif
		if ((buf[k] & 0xFFFFFF) != data[k])
		  flag = 1;
	    }
	    if (flag == 0)
	        sqigno++;
	    else {
		printf("qigno error i=%d j=%d\n", i, j);
		print_flag = 1;
		eqigno++;
		break;
	    }
	}

	for (j = 2; j < MAXBUF; j += STEP) {
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(0, NAF(CAMAC_MEMORY, 0, 16), zeros, j, &retlen, &err);
	    if (err != 0)
		printf("qstow clear error err=0x%x i=%d j=%d\n", err, i, j);

	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(0, NAF(CAMAC_MEMORY, 0, 16), datas, j, &retlen, &err);
	    if (err != 0)
		printf("qstow write error err=0x%x i=%d j=%d\n", err, i, j);

	    for (k = 0; k < j; k += STEP)
	        bufs[k] = 2;
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(0, NAF(CAMAC_MEMORY, 0, 0), bufs, j, &retlen, &err);
	    if (err != 0)
		printf("qstow read error  err=0x%x i=%d j=%d\n", err, i, j);

	    flag = 0;
	    for (k = 0; k < j; k += STEP) {
#ifdef PRINT
		if (print_flag != 0)
		printf("bufs[%d]=0x%x datas[%d]=0x%x\n",
		       k, bufs[k], k, datas[k]);
#endif
		if (bufs[k] != datas[k])
		  flag = 1;
	    }
	    if (flag == 0)
	        sqstopw++;
	    else {
		printf("qstopw error i=%d j=%d\n", i, j);
		print_flag = 1;
		eqstopw++;
		break;
	    }
	}

	for (j = 2; j < MAXBUF; j += STEP) {
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(1, NAF(CAMAC_MEMORY, 0, 16), zeros, j, &retlen, &err);
	    if (err != 0)
		printf("qignw clear error err=0x%x i=%d j=%d\n", err, i, j);

	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(1, NAF(CAMAC_MEMORY, 0, 16), datas, j, &retlen, &err);
	    if (err != 0) 
		printf("qignw write error err=0x%x i=%d j=%d\n", err, i, j);

	    for (k = 0; k < j; k += STEP)
	        bufs[k] = 2;
	    CAMAC(NAF(CAMAC_MEMORY, 0,  17), &dat, &q, &x);
	    CDMAW(1, NAF(CAMAC_MEMORY, 0, 0), bufs, j, &retlen, &err);
	    if (err != 0)
		printf("qignw read error  err=0x%x i=%d j=%d\n", err, i, j);

	    flag = 0;
	    for (k = 0; k < j; k += STEP) {
#ifdef PRINT
		if (print_flag != 0)
		printf("bufs[%d]=0x%x datas[%d]=0x%x\n",
		       k, bufs[k], k, datas[k]);
#endif
		if (bufs[k] != datas[k])
		  flag = 1;
	    }
	    if (flag == 0)
	        sqignow++;
	    else {
		printf("qignow error i=%d j=%d\n", i, j);
		print_flag = 1;
		eqignow++;
		break;
	    }
	}



/****************************
 *  interrupt               *
 ****************************/
	printf("*** interrupt *** %d\n", i);





/****************************
 *  list                    *
 ****************************/
	printf("*** list *** %d\n", i);
	flag = 0;
/* read camac list */
	status = CamReaLIST(filename, list, MAXLIST, &lenlis, &err);
	if (status) {
	    printf("Read list error!\n");
	    flag = 1;
	}
	  
/* install the list */
	status = CamLisLOAD(list, lenlis, &err);
	if (status) {
	    printf("Load list error!\n");
	    flag = 1;
	}

/* set S register initial value */
	iosb.s_reg = s;

/* Execute */
	status = CamExeWAIt(bufs, MAXBUF, &iosb);
	if (status) {
	    printf("Execute list error!\n");
	    flag = 1;
	}
	if (iosb.s_reg != 1) {
	    printf("S-reg error! s_reg=0x%x\n", iosb.s_reg);
	    flag = 1;
	}

	if (flag == 0)
	    slist++;
	else {
	    printf("list error i=%d \n", i);
	    elist++;
	}
    }

/* show status */
    printf("\n");
    printf("esinglew = %d\n", esinglew);
    printf("eqstopw  = %d\n", eqstopw);
    printf("eqignow  = %d\n", eqignow);
    printf("esingle  = %d\n", esingle);
    printf("eqstop   = %d\n", eqstop);
    printf("eqigno   = %d\n", eqigno);
    printf("einter   = %d\n", einter);
    printf("elist    = %d\n", elist);
    printf("\n");
    printf("ssinglew = %d\n", ssinglew);
    printf("sqstopw  = %d\n", sqstopw);
    printf("sqignow  = %d\n", sqignow);
    printf("ssingle  = %d\n", ssingle);
    printf("sqstop   = %d\n", sqstop);
    printf("sqigno   = %d\n", sqigno);
    printf("sinter   = %d\n", sinter);
    printf("slist    = %d\n", slist);
    printf("\n");

/* end */
    CAM_Close();
}
